/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;


/**
 * @author obper
 */
@Entity
@Table(name = "ajuste")
@NamedQueries({
        @NamedQuery(name = "Ajuste.findAll", query = "SELECT a FROM Ajuste a"),
        @NamedQuery(name = "Ajuste.findByAjusteCodigo", query = "SELECT a FROM Ajuste a WHERE a.ajusteCodigo = :ajusteCodigo"),
        @NamedQuery(name = "Ajuste.findByAjusteFecha", query = "SELECT a FROM Ajuste a WHERE a.ajusteFecha = :ajusteFecha"),
        @NamedQuery(name = "Ajuste.findByProgramaCodigo", query = "SELECT a FROM Ajuste a WHERE a.programaCodigo = :programaCodigo"),
        @NamedQuery(name = "Ajuste.findByAjusteObservacion", query = "SELECT a FROM Ajuste a WHERE a.ajusteObservacion = :ajusteObservacion"),
        @NamedQuery(name = "Ajuste.findByAjusteInventario", query = "SELECT a FROM Ajuste a WHERE a.ajusteInventario = :ajusteInventario"),
        @NamedQuery(name = "Ajuste.findByAjusteEnvio", query = "SELECT a FROM Ajuste a WHERE a.ajusteEnvio = :ajusteEnvio")})
public class Ajuste implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 5)
    @Column(name = "ajuste_codigo")
    private String ajusteCodigo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "ajuste_fecha")
    @Temporal(TemporalType.DATE)
    private Date ajusteFecha;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 3)
    @Column(name = "programa_codigo")
    private String programaCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "ajuste_observacion")
    private String ajusteObservacion;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 7)
    @Column(name = "ajuste_inventario")
    private String ajusteInventario;
    @Size(max = 1)
    @Column(name = "ajuste_envio")
    private String ajusteEnvio;
    @JoinColumn(name = "sucursal_codigo", referencedColumnName = "sucursal_codigo")
    @ManyToOne(optional = false)
    private Sucursales sucursalCodigo;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "ajuste")
    private Collection<DetalleAjuste> detalleAjusteCollection;

    public Ajuste() {
    }

    public Ajuste(String ajusteCodigo) {
        this.ajusteCodigo = ajusteCodigo;
    }

    public Ajuste(String ajusteCodigo, Date ajusteFecha, String programaCodigo, String ajusteObservacion, String ajusteInventario) {
        this.ajusteCodigo = ajusteCodigo;
        this.ajusteFecha = ajusteFecha;
        this.programaCodigo = programaCodigo;
        this.ajusteObservacion = ajusteObservacion;
        this.ajusteInventario = ajusteInventario;
    }

    public String getAjusteCodigo() {
        return ajusteCodigo;
    }

    public void setAjusteCodigo(String ajusteCodigo) {
        this.ajusteCodigo = ajusteCodigo;
    }

    public Date getAjusteFecha() {
        return ajusteFecha;
    }

    public void setAjusteFecha(Date ajusteFecha) {
        this.ajusteFecha = ajusteFecha;
    }

    public String getProgramaCodigo() {
        return programaCodigo;
    }

    public void setProgramaCodigo(String programaCodigo) {
        this.programaCodigo = programaCodigo;
    }

    public String getAjusteObservacion() {
        return ajusteObservacion;
    }

    public void setAjusteObservacion(String ajusteObservacion) {
        this.ajusteObservacion = ajusteObservacion;
    }

    public String getAjusteInventario() {
        return ajusteInventario;
    }

    public void setAjusteInventario(String ajusteInventario) {
        this.ajusteInventario = ajusteInventario;
    }

    public String getAjusteEnvio() {
        return ajusteEnvio;
    }

    public void setAjusteEnvio(String ajusteEnvio) {
        this.ajusteEnvio = ajusteEnvio;
    }

    public Sucursales getSucursalCodigo() {
        return sucursalCodigo;
    }

    public void setSucursalCodigo(Sucursales sucursalCodigo) {
        this.sucursalCodigo = sucursalCodigo;
    }

    public Collection<DetalleAjuste> getDetalleAjusteCollection() {
        return detalleAjusteCollection;
    }

    public void setDetalleAjusteCollection(Collection<DetalleAjuste> detalleAjusteCollection) {
        this.detalleAjusteCollection = detalleAjusteCollection;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (ajusteCodigo != null ? ajusteCodigo.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Ajuste)) {
            return false;
        }
        Ajuste other = (Ajuste) object;
        if ((this.ajusteCodigo == null && other.ajusteCodigo != null) || (this.ajusteCodigo != null && !this.ajusteCodigo.equals(other.ajusteCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "dbCon.Ajuste[ ajusteCodigo=" + ajusteCodigo + " ]";
    }

}
